/*
 *
 * Copyright (c) 1997-1999 Scott Oaks and Henry Wong. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 * This sample source code is provided for example only,
 * on an unsupported, as-is basis. 
 *
 * AUTHOR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. AUTHOR SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  AUTHOR
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */


import java.applet.Applet;
import java.awt.*;

public class Fractal extends Applet implements Runnable {
	Thread t;
	boolean shouldRun = false;
	Object runLock = new Object();
	int nSections;

	public void start() {
		if (t == null) {
			shouldRun = true;	
			t = new Thread(this);
			t.setPriority(Thread.currentThread().getPriority() - 1);
			t.start();
		}
		else {
			synchronized(runLock) {
				shouldRun = true;
				runLock.notify();
			}
		}
	}

	public void stop() {
		shouldRun = false;
	}

	void doCalc(int i) {
		// calculate the ith section of the fractal
	}

	public void run() {
		for (int i = 0; i < nSections; i++) {
			doCalc(i);
			repaint();
			synchronized(runLock) {
				while (shouldRun == false)
					try {
						runLock.wait();
					} catch (InterruptedException ie) {}
			}
		}
	}

	public void paint(Graphics g) {
		// Paint the completed sections of the fractal
	}
}
